<id>
Notify Once SP1.2/1.3/1.3.1
</id>

<version>
2.0 beta 2
</version>

<mod info>
Tired of receiving an email everytime someone replied to a message you're watching? Then try the new and improved "Notify Once"!
No longer will your inbox be flooded with almost identical emails - instead receive a single message saying one or more users have replied.


How to install:
1...Apply the mod file, upload the modified files.
2...Replace your existing Notify.pl file with the one supplied.

New in version 2.0:
1...Javascript confirmation added to notify links.
2...Board level notification of new topics.
3...Admin options to select [disable notification/notify on every post/notify once] for both reply and new topic notification.
4...Compatibility added with Poll mod and Rebuild Message Index.
5...Lots of other cosmetic and fun stuff!

Note:
This mod is incompatible with notify plus!
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

###############################################################################

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
### Notify Once 2.0 ###
%bln_txt=(
	'01a',	"Topic Reply Notification",
	'01b',	"New Topic Notification",
	'02',	"Notify of new topics",
	'03',	"Would you like a notification Email if someone starts a new topic on this board\?",
	'04',	"Would you like to deactivate Notification of new topics on this board\?",
	'05a',	"You are being notified of new topics in the following boards",
	'05b',	"You are notified on replies in the following topics",
	'06a',	"A reply",
	'06b',	"has been posted by",
	'06c',	"to a topic you are watching on the $mbname.\n\nView it at",
	'07a',	"One or more replies have been posted to the topic",
	'07b',	"that you are watching on the $mbname.\n\nView it at",
	'08a',	"A new topic",
	'08b',	"has been posted by",
	'08c',	"to the",
	'08d',	"forum that you are watching on the $mbname.\n\nView it at",
	'09a',	"One or more new topics have been posted to the",
	'09b',	"forum that you are watching on the $mbname.\n\nView it at",
	'10',	"a guest",
	'11',	"Enable Board Level Notification of New Topics?",
	'12',	"Enable Email Notification of Replies?",
	'13',	"Send a seperate email notification for every new topic created on these boards?",
	'14',	"Send a seperate email notification for every reply to these threads?",
	'15',	"Send individual notification emails",
	'16',	"Board",
	'17',	"Thread"
);
### Notify Once 2.0 ###

</add before>

<search for>
	$img{'notify'} = qq~<font size="1" class="imgcatbg">$txt{'131'}</font>~;
</search for>

<add after>
	$img{'notify_b'} = qq~<font size="1" class="imgcatbg">$bln_txt{'02'}</font>~;
</add after>

<search for>
	$img{'notify'} = qq~<img src="$imagesdir/notify.gif" alt="$txt{'131'}" border="0"> <font size="1" class="imgcatbg">$txt{'131'}</font>~;
</search for>

<add after>
	$img{'notify_b'} = qq~<img src="$imagesdir/notify.gif" alt="$bln_txt{'02'}" border="0"> <font size="1" class="imgcatbg">$bln_txt{'02'}</font>~;
</add after>

###############################################################################

<edit file>
Sources/Admin.pl
</edit file>

<search for>
	unlink("$memberdir/$currentmem.imconfig");
</search for>

<add after>
	unlink("$memberdir/$currentmem.not");
</add after>

###############################################################################

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	if ($enable_notification) { $notifchecked = "checked" }
</search for>

<replace>
	if ($enable_board_notify) { $ebnchecked = " checked"; }
	if ($enable_notification) { $ernchecked = " checked" }
</replace>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification" $notifchecked></td>
  </tr><tr>
</search for>

<replace>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$bln_txt{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="enable_board_notify" value="1"$ebnchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$bln_txt{'12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="enable_notification" value="1"$ernchecked></td>
  </tr><tr>
</replace>

<search for>
	$timeselected = $FORM{'timeselect'} || 0;
</search for>

<add after>
	$enable_board_notify = $FORM{'enable_board_notify'} || 0;
	$enable_notification = $FORM{'enable_notification'} || 0;
</add after>

<search for>
\$enable_notification = $enable_notification;		# Allow e-mail notification
</search for>

<replace>
\$enable_board_notify = $enable_board_notify;		# Allow e-mail notification of new topics
\$enable_notification = $enable_notification;		# Allow e-mail notification of replies
</replace>

###############################################################################

<edit file>
sources/Display.pl
</edit file>

<search for>
	if($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify;thread=$viewnum;start=$startnum">$img{'notify'}</a>~;
	}
</search for>

<replace>
	$notify = '';
	# Update notification file that the thread has been viewed.
	if($enable_notification && $username ne 'Guest') {
		my $startnum = $start || '0';
		$notify = qq~<a href="$cgi;action=notify2;thread=$viewnum;start=$startnum" onclick="javascript:return confirm('$txt{'126'}')">$img{'notify'}</a>$menusep~;
		if(-e("$datadir/$viewnum.mail"))  {
			my $i = 0;
			my $found = 0;
			fopen(FILE, "$datadir/$viewnum.mail");
			@mails = <FILE>;
			fclose(FILE);
			foreach $curmail (@mails) {
				chomp $curmail;
				($curmail, $mail_sent, $notify_type) = split(/\|/,$curmail);
				if ($curmail eq $settings[2]) {
					$notify = qq~<a href="$cgi;action=notify3;thread=$viewnum;start=$startnum" onclick="javascript:return confirm('$txt{'212'}')">$img{'notify'}</a>$menusep~;
					if ($mail_sent == 1) {$mail_sent = 0; $found = 1;}
				}
				$mails[$i] = "$curmail|$mail_sent|$notify_type\n";
				$i++;
			}
			if ($found == 1) {
				fopen(FILE, ">$datadir/$viewnum.mail");
				print FILE @mails;
				fclose(FILE);
			}
		}
	}

</replace>

###############################################################################

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
		unlink("$boardsdir/$curboard.ctb");
</search for>

<add after>
		unlink("$boardsdir/$curboard.mail");
</add after>

###############################################################################

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	# Load censor list.
</search for>

<add before>
	$notify = '';
	# Update notification file that the board has been viewed.
	if($enable_board_notify && $username ne 'Guest') {
		$notify = qq~$menusep<a href="$cgi;action=notify2" onclick="javascript:return confirm('$bln_txt{'03'}')" class="altlink">$img{'notify_b'}</a>~;
		if(-e("$boardsdir/$currentboard.mail"))  {
			my $i = 0;
			my $found = 0;
			fopen(FILE, "$boardsdir/$currentboard.mail");
			@mails = <FILE>;
			fclose(FILE);
			foreach $curmail (@mails) {
				chomp $curmail;
				($curmail, $mail_sent, $notify_type) = split(/\|/,$curmail);
				if ($curmail eq $settings[2]) {
					$notify = qq~$menusep<a href="$cgi;action=notify3" onclick="javascript:return confirm('$bln_txt{'04'}')" class="altlink">$img{'notify_b'}</a>~;
					if ($mail_sent == 1) {$mail_sent = 0; $found = 1;}
				}
				$mails[$i] = "$curmail|$mail_sent|$notify_type\n";
				$i++;
			}
			if ($found == 1) {
				fopen(FILE, ">$boardsdir/$currentboard.mail");
				print FILE @mails;
				fclose(FILE);
			}
		}
	}

</add before>

<search for>
if($showmarkread) {
	$yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~;
}
</search for>

<add after>
if($enable_board_notify) {
	$yymain .= $notify;
}
</add after>

<search for>
	if($showmarkread) { $yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~; }
</search for>

<add after>
	if($enable_board_notify) { $yymain .= $notify; }
</add after>

###############################################################################

<edit file>
Sources/Post.pl
</edit file>

<search for>
	# Notify any members who have notification turned on for this thread.
	if(-e("$datadir/$thread.mail")) { &NotifyUsers; }
</search for>

<replace>
	# Notify any members who have notification turned on for this thread.
	if($enable_notification && $threadid && -e("$datadir/$threadid.mail")) {&NotifyUsers("$datadir/$threadid.mail", "$msub", "$subject", 0, $mreplies);}
	elsif($enable_board_notify && $newthreadid && -e("$boardsdir/$currentboard.mail")) {&NotifyUsers("$boardsdir/$currentboard.mail", "$subject", "$subject", 1, $mreplies);}
</replace>

<search for>
sub NotifyUsers {
	$subject = $FORM{'subject'};

	fopen(FILE, "$datadir/$thread.mail") || return 0;
	@mails = <FILE>;
	fclose(FILE);
	foreach $curmail (@mails) {
		chomp $curmail;
		if ($curmail ne $settings[2]) {
			&sendmail($curmail,"$txt{'127'}\:  $subject","$txt{'128'}, $subject, $txt{'129'} $cgi;action=display;num=$thread\n\n$txt{'130'}");
		}
	}
	return 1;
}
</search for>

<replace>
sub NotifyUsers {
	my $tmp_filename = $_[0];
	my $tmp_subject1 = $_[1];
	my $tmp_subject2 = $_[2];
	my $tmp_board_notify = $_[3] ? 1 : 0;
	my $tmp_replies = $_[4] || 0;
	my $tmp_name = $settings[1] || $bln_txt{'10'};
	if ($tmp_board_notify) {
		fopen(FILE, "$boardsdir/$currentboard.dat");
		$bname = <FILE>;
		fclose(FILE);
		chomp $bname;
	}

	fopen(FILE, "$tmp_filename") || return 0;
	@mails = <FILE>;
	fclose(FILE);
	my $i = 0;
	my $found = 0;
	foreach $curmail (@mails) {
		chomp $curmail;
		($curmail, $mail_sent, $notify_type) = split(/\|/,$curmail);
		if ($tmp_board_notify == 1 && $notify_type == 1) {
			# Notify of every new thread
			$mail_sent = 0;
			$tmp_email_subject = "$bln_txt{'01b'}\: $tmp_subject1";
			$tmp_email_message = "$bln_txt{'08a'}, \"$tmp_subject1\", $bln_txt{'08b'} $tmp_name $bln_txt{'08c'} \"$bname\" $bln_txt{'08d'} $cgi;action=display;num=$thread\n\n$txt{'130'}";
		} elsif ($tmp_board_notify == 1 && $notify_type != 1) {
			# Notify once of new threads
			$tmp_email_subject = "$bln_txt{'01b'}";
			$tmp_email_message = "$bln_txt{'09a'} \"$bname\" $bln_txt{'09b'} $cgi\n\n$txt{'130'}";
		} elsif ($tmp_board_notify != 1 && $notify_type == 1) {
			# Notify of every new reply
			$mail_sent = 0;
			$tmp_email_subject = "$bln_txt{'01a'}\: $tmp_subject1";
			$tmp_email_message = "$bln_txt{'06a'}, \"$tmp_subject2\", $bln_txt{'06b'} $tmp_name $bln_txt{'06c'} $cgi;action=display;num=$thread;start=$tmp_replies\n\n$txt{'130'}";
		} elsif ($tmp_board_notify != 1 && $notify_type != 1) {
			# Notify once of new replies
			$tmp_email_subject = "$bln_txt{'01a'}\: $tmp_subject1";
			$tmp_email_message = "$bln_txt{'07a'}, \"$tmp_subject1\", $bln_txt{'07b'} $cgi;action=display;num=$thread\n\n$txt{'130'}";
		}
		if ($curmail ne $settings[2] && $mail_sent != 1) {
			&sendmail($curmail,"$tmp_email_subject","$tmp_email_message");
			$mail_sent = 1; $found = 1;
		}
		$mails[$i] = "$curmail|$mail_sent|$notify_type\n";
		$i++;
	}
	if ($found == 1) {
		fopen(FILE, ">$tmp_filename");
		print FILE @mails;
		fclose(FILE);
	}
	return 1;
}
</replace>

###############################################################################

<edit file>
Sources/Profile.pl
</edit file>

<search for>
        <font size="1">$txt{'421'}</font><br><br></td>
        <td><input type="text" name="dr" size="20" value="$dr"><br><br></td>
      </tr>~;
</search for>

<add after>
	fopen(FILE, "$memberdir/$INFO{'username'}.not");
		my $tmp_board_notify = <FILE> || 0;
		my $tmp_thread_notify = <FILE> || 0;
	fclose(FILE);
	chomp $tmp_board_notify;
	chomp $tmp_thread_notify;

	$nbchecked = $tmp_board_notify == 1 ? " checked" : "";
	$ntchecked = $tmp_thread_notify == 1 ? " checked" : "";

	$yymain .= qq~
      <tr>
        <td width="320"><font size="2"><b>$bln_txt{'15'}:</b></td>
        <td>$bln_txt{'16'}: <input type="checkbox" name="notify_board" size="20" value="1"$nbchecked> &nbsp; &nbsp; $bln_txt{'17'}: <input type="checkbox" name="notify_thread" size="20" value="1"$ntchecked></td>
      </tr>~;
</add after>


<search for>
		fopen(MEMBERFILEREAD,"$memberdir/$member{'username'}.dat");
		my @memset = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @memset;
		require "$sourcedir/Notify.pl";
		replace_notifications($memset[2],$member{'email'});
</search for>

<replace>
		fopen(MEMBERFILEREAD,"$memberdir/$member{'username'}.dat");
		my @memset = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		$oldemail = $memset[2];
		chomp $oldemail;

		fopen(FILE, "$memberdir/$member{'username'}.not");
			my $old_notifyboard = <FILE> || 0;
			my $old_notifythread = <FILE> || 0;
		fclose(FILE);
		chomp $old_notifyboard;
		chomp $old_notifythread;

		if( $settings[7] ne 'Administrator' ) {
			$member{'notify_board'} = $old_notifyboard ? 1 : 0;
			$member{'notify_thread'} = $old_notifythread ? 1 : 0;
		} else {
			$member{'notify_board'} = $FORM{'notify_board'} ? 1 : 0;
			$member{'notify_thread'} = $FORM{'notify_thread'} ? 1 : 0;
		}

		# if changed email address, update notifications
		if ($member{'email'} ne $oldemail || $member{'notify_board'} ne $old_notifyboard || $member{'notify_thread'} ne $old_notifythread) {
			fopen(FILE, ">$memberdir/$member{'username'}.not");
				print FILE "$member{'notify_board'}\n";
				print FILE "$member{'notify_thread'}\n";
			fclose(FILE);
			require "$sourcedir/Notify.pl";
			if ($member{'email'} ne $oldemail || $member{'notify_board'} ne $old_notifyboard) {&replace_notifications($oldemail, $member{'email'}, $member{'notify_board'}, 0);}
			if ($member{'email'} ne $oldemail || $member{'notify_thread'} ne $old_notifythread) {&replace_notifications($oldemail, $member{'email'}, $member{'notify_thread'}, 1);}
		}
</replace>

<search for>
	                unlink("$memberdir/$member{'username'}.imconfig");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.not");
</add after>

<search for>
	                unlink("$memberdir/$username.imconfig");
</search for>

<add after>
	                unlink("$memberdir/$username.not");
</add after>

